# Projekt II na Pracownię Programowania

---
Aplikacja używa [PostgreSQL](https://www.postgresql.org/download/)

## Ważne:
1. Przed uruchomieniem programu należy w pliku `src/main/resources/META-INF/persistence.xml`
ustawić nazwę użytkownika i hasło (oraz url - jeśli nie użyło się domyslnych wartości przy instalacji [Postgresu](https://www.postgresql.org/download/)) na własne.
2. W `persistence.xml` pole `hibernate.hbm2ddl.auto` jest domyślnie ustawione na  `create`, tj. baza będzie usuwana i tworzona na nowo przy każdym uruchomieniu aplikacji.
Aby baza nie była resetowana, należy ustawić wartość tego pola np. na `update`.
3. `Main` przedstawia jedynie prosty przykład użycia dostępnych zapytań.

## Klasy/Tabele i ich własności:
- **Book (books)** - Klasa reprezentująca tabelę o książkach. Relacja *one-to-many* z **authors_books** i *many-to-one* z **genres**.
- **Author (authors)** - Klasa reprezentująca tabelę o autorach książek. Relacja *one-to-many* z **authors_books**.
- **AuthorBook (authors_books)** - Klasa reprezentująca tabelę łączącą dla tabel **books** i **authors** (potrzebne do relacji *many-to-many*).
- **Bestseller (bestsellers)** - Klasa reprezentująca tabelę o książkach-bestsellerach. Relacja *one-to-one* z **books**.
- **Genre (genres)** - Klasa reprezentująca tabelę o gatunkach książek.

*Wszystkie klasy mają alternatywne metody dla podstawowych operacji CRUD*.